🐥 deploy-canary:
  only:
    refs:
    - /^release[\/\-].+[\/\-].+/
    #  image: reghbpr01.dc1.true.th/tools/kustomize-docker:v-3.5.3.2
  image: reghbpr01.dc1.true.th/tools/kustomize-docker:v-4.0.5
  when: manual
  needs: ["waiting-approve"]
  tags:
    - docker-itsd
  stage: deploy-canary
  artifacts:
    when: always
    paths:
    - kubernetes
    expire_in: 7 day
  script: 
    # - export KUBECONFIG=$(env | grep PROD_KUBECONFIG | awk -F '=' '{print $2}')
    - export env=canary
    - cd kubernetes
    - if [ -z $image ]; then export image=${HABOR_REG}/${namespace}/${CI_PROJECT_NAME}; fi;
    - if [ -z $imageTag ]; then export imageTag=\"${CI_COMMIT_SHA:0:8}\"; fi;
    - for f in base/*.yaml ; do echo $f;envsubst <$f > $f-temp && mv $f-temp $f ;sed -i 's/arctic.true.th/atlantic.true.th/g' $f ; done; 
    # - envsubst <base/manifest.yaml > base/manifest-temp.yaml && mv base/manifest-temp.yaml base/manifest.yaml
    - envsubst <overlay/${env}/kustomization.yaml > overlay/${env}/kustomization_tmp.yaml && mv overlay/${env}/kustomization_tmp.yaml  overlay/${env}/kustomization.yaml
    - kustomize build overlay/${env} ${kustom_option} > output-${env}.yaml;
    - cat output-${env}.yaml;
    - |
      if [ -z $PROD_SITE ];
        then export LIST=PROD_KUBECONFIG;
      else
        for item in $(echo $PROD_SITE | sed "s/,/ /g")
        do
          if [ $item == "default" ];
          then
            export LIST=${LIST}PROD_KUBECONFIG,
          else
            export LIST=${LIST}PROD_KUBECONFIG_${item},
          fi;
        done;
        export LIST=${LIST::-1}
      fi;
    - echo "Cluster List ${LIST}"
    - |
      for cluster in $(echo $LIST | sed "s/,/ /g")
      do
        echo "Deploying ${cluster}";
        export KUBECONFIG=$(eval echo $"${cluster}");
        echo $KUBECONFIG;
        kubectl apply -f output-${env}.yaml;
      done;
    # - kubectl apply -f output-${env}.yaml;
    
  after_script:
    - curl $BISMARCK_HOST/completed/$CI_PIPELINE_ID/canary/$GITLAB_USER_EMAIL

🐥 remove-canary:
  only:
    refs:
    - /^release[\/\-].+[\/\-].+/
    #  image: reghbpr01.dc1.true.th/tools/kustomize-docker:v-3.5.3.2
  image: reghbpr01.dc1.true.th/tools/kustomize-docker:v-4.0.5
  when: manual
  needs: ["🐥 deploy-canary"]
  tags:
    - docker-itsd
  stage: rollout
  artifacts:
    when: always
    paths:
    - kubernetes
    expire_in: 1 day
  script: 
    # - export KUBECONFIG=$(env | grep PROD_KUBECONFIG | awk -F '=' '{print $2}')
    - export env=canary
    - cd kubernetes
    # - kubectl delete -f output-${env}.yaml;
    - |
      if [ -z $PROD_SITE ];
        then export LIST=PROD_KUBECONFIG;
      else
        for item in $(echo $PROD_SITE | sed "s/,/ /g")
        do
          if [ $item == "default" ];
          then
            export LIST=${LIST}PROD_KUBECONFIG,
          else
            export LIST=${LIST}PROD_KUBECONFIG_${item},
          fi;
        done;
        export LIST=${LIST::-1}
      fi;
    - echo "Cluster List ${LIST}"
    - |
      for cluster in $(echo $LIST | sed "s/,/ /g")
      do
        echo "Deploying ${cluster}";
        export KUBECONFIG=$(eval echo $"${cluster}");
        echo $KUBECONFIG;
        kubectl delete -f output-${env}.yaml;
      done;